import java.awt.*;
import java.awt.event.*;
public class Graafik5 extends Canvas{
  double minx=-10, maxx=10, samm=(maxx-minx)/20;
  double miny=minY(), maxy=maxY();
  double ulatusmin=0.01, ulatusx, ulatusy;
  int korgus, laius;
  int servaruum=25;
  double koefitsentx, koefitsenty, keskx, kesky; 

  public void paint(Graphics g){
    leiaKonstandid();
    joonistaKoordinaadid(g);
    int vanax=ekraaniX(minx);
    int vanay=ekraaniY(f(minx));
    for(double x=minx; x<=maxx; x=x+samm){
      int uusx=ekraaniX(x);
      int uusy=ekraaniY(f(x));      
      g.drawLine(vanax, vanay, uusx, uusy);
      vanax=uusx;
      vanay=uusy;
    }
  }

  int ekraaniX(double matemx){
    return laius/2+(int)((matemx-keskx)*koefitsentx);
  }

  int ekraaniY(double matemy){
    return korgus/2+(int)((matemy-kesky)*koefitsenty);
  }

  double minY(){
    double min=f(minx);
    for(double x=minx; x<=maxx; x+=samm){
      if(f(x)<min)min=f(x);
    }
    return min;
  }

  double maxY(){
    double max=f(minx);
    for(double x=minx; x<=maxx; x+=samm){
      if(f(x)>max)max=f(x);
    }
    return max;
  }

  void leiaKonstandid(){
    korgus=getSize().height;
    laius=getSize().width;    
    ulatusx=maxx-minx; 
    ulatusy=maxy-miny;
    if(ulatusx<ulatusmin)ulatusx=ulatusmin;
    if(ulatusy<ulatusmin)ulatusy=ulatusmin;
    koefitsentx=(laius-2*servaruum)/ulatusx;
    koefitsenty=-(korgus-2*servaruum)/ulatusy;
    keskx=(maxx+minx)/2;
    kesky=(maxy+miny)/2;
  }
  
  void joonistaKoordinaadid(Graphics g){
    int numbreidy=(korgus-2*servaruum)/30;
    int numbreidx=(laius-2*servaruum)/40;
    for(int i=0; i<=numbreidx; i++){
      double x=umarda(minx+i/(double)numbreidx*(maxx-minx), 2);
      g.drawString(x+"", ekraaniX(x), korgus-5 );
    }
    for(int i=0; i<=numbreidy; i++){
      double y=umarda(miny+i/(double)numbreidy*(maxy-miny), 2);
      g.drawString(y+"", 3,  ekraaniY(y));
    }
  }
  
  double umarda(double arv, int kohti){
    return(Math.round(arv*Math.pow(10, kohti))/Math.pow(10, kohti));
  }
 
  double f(double x){  
    return x*x;
  }

 
  public static void main(String argumendid[]){
    final Frame f=new Frame("Ruutfunktsiooni graafik");
    f.add(new Graafik5());
    f.setSize(250, 250);
    f.setVisible(true);
    f.addWindowListener(new WindowAdapter(){
      public void windowClosing(WindowEvent e){
        f.setVisible(false);
        System.exit(0);
      }
    });
  }
}